/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.cpu.decoder;

import static ru.ispras.microtesk.model.cpu.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.cpu.op.alu_instr;
import ru.ispras.microtesk.model.IsaPrimitive;

/**
 * The {@code DecoderAlu_instr} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderAlu_instr extends DecoderItem {
  private static DecoderAlu_instr instance = null;

  public static DecoderAlu_instr get() {
    if (null == instance) {
      instance = new DecoderAlu_instr();
    }
    return instance;
  }

  private DecoderAlu_instr() {
    super(
        16,
        true,
        "0000000000000000",
        "0000000011000000"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    IsaPrimitive command = null;
    IsaPrimitive op1 = null;
    IsaPrimitive op2 = null;

    command = (IsaPrimitive) readNextPrimitive(image, DecoderALU.get());
    if (null == command) {
      return null;
    }

    op1 = (IsaPrimitive) readNextPrimitive(image, DecoderOPRNDL.get());
    if (null == op1) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("00", 2, 2))) {
      return null;
    }

    op2 = (IsaPrimitive) readNextPrimitive(image, DecoderOPRNDR.get());
    if (null == op2) {
      return null;
    }

    return newResult(new alu_instr(command, op1, op2));
  }
}
