/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.decoder;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.mips64.op.bc1f;
import ru.ispras.microtesk.model.Immediate;

/**
 * The {@code DecoderBc1f} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderBc1f extends DecoderItem {
  private static DecoderBc1f instance = null;

  public static DecoderBc1f get() {
    if (null == instance) {
      instance = new DecoderBc1f();
    }
    return instance;
  }

  private DecoderBc1f() {
    super(
        32,
        true,
        "01000101000000000000000000000000",
        "11111111111000110000000000000000"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    Immediate cc = null;
    Immediate offset = null;

    if (!matchNextOpc(image, BitVector.valueOf("01000101000", 2, 11))) {
      return null;
    }

    cc = readNextImmediate(image, Type.CARD(3));

    if (!matchNextOpc(image, BitVector.valueOf("00", 2, 2))) {
      return null;
    }

    offset = readNextImmediate(image, SHORT);

    return newResult(new bc1f(cc, offset));
  }
}
