/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.decoder;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.mips64.op.cvts_pu;
import ru.ispras.microtesk.model.mips64.mode.FR;

/**
 * The {@code DecoderCvts_pu} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderCvts_pu extends DecoderItem {
  private static DecoderCvts_pu instance = null;

  public static DecoderCvts_pu get() {
    if (null == instance) {
      instance = new DecoderCvts_pu();
    }
    return instance;
  }

  private DecoderCvts_pu() {
    super(
        32,
        true,
        "01000110110000000000000000100000",
        "11111111111111110000000000111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    FR fd = null;
    FR fs = null;

    if (!matchNextOpc(image, BitVector.valueOf("0100011011000000", 2, 16))) {
      return null;
    }

    fs = (FR) readNextPrimitive(image, DecoderFR.get());
    if (null == fs) {
      return null;
    }

    fd = (FR) readNextPrimitive(image, DecoderFR.get());
    if (null == fd) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("100000", 2, 6))) {
      return null;
    }

    return newResult(new cvts_pu(fd, fs));
  }
}
