/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.decoder;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.mips64.op.dmtc2;
import ru.ispras.microtesk.model.mips64.mode.R;
import ru.ispras.microtesk.model.Immediate;

/**
 * The {@code DecoderDmtc2} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderDmtc2 extends DecoderItem {
  private static DecoderDmtc2 instance = null;

  public static DecoderDmtc2 get() {
    if (null == instance) {
      instance = new DecoderDmtc2();
    }
    return instance;
  }

  private DecoderDmtc2() {
    super(
        32,
        true,
        "01001000101000000000000000000000",
        "11111111111000000000000000000000"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    R rt = null;
    R rd = null;
    Immediate sel = null;

    if (!matchNextOpc(image, BitVector.valueOf("01001000101", 2, 11))) {
      return null;
    }

    rt = (R) readNextPrimitive(image, DecoderR.get());
    if (null == rt) {
      return null;
    }

    rd = (R) readNextPrimitive(image, DecoderR.get());
    if (null == rd) {
      return null;
    }

    sel = readNextImmediate(image, Type.CARD(11));

    return newResult(new dmtc2(rt, rd, sel));
  }
}
