/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.decoder;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.mips64.op.ldc1;
import ru.ispras.microtesk.model.mips64.mode.FR;
import ru.ispras.microtesk.model.Immediate;
import ru.ispras.microtesk.model.mips64.mode.R;

/**
 * The {@code DecoderLdc1} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderLdc1 extends DecoderItem {
  private static DecoderLdc1 instance = null;

  public static DecoderLdc1 get() {
    if (null == instance) {
      instance = new DecoderLdc1();
    }
    return instance;
  }

  private DecoderLdc1() {
    super(
        32,
        true,
        "11010100000000000000000000000000",
        "11111100000000000000000000000000"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    FR ft = null;
    Immediate offset = null;
    R base = null;

    if (!matchNextOpc(image, BitVector.valueOf("110101", 2, 6))) {
      return null;
    }

    base = (R) readNextPrimitive(image, DecoderR.get());
    if (null == base) {
      return null;
    }

    ft = (FR) readNextPrimitive(image, DecoderFR.get());
    if (null == ft) {
      return null;
    }

    offset = readNextImmediate(image, SHORT);

    return newResult(new ldc1(ft, offset, base));
  }
}
