/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.decoder;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.mips64.op.wait;
import ru.ispras.microtesk.model.Immediate;

/**
 * The {@code DecoderWait} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderWait extends DecoderItem {
  private static DecoderWait instance = null;

  public static DecoderWait get() {
    if (null == instance) {
      instance = new DecoderWait();
    }
    return instance;
  }

  private DecoderWait() {
    super(
        32,
        true,
        "01000010000000000000000000100000",
        "11111110000000000000000000111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    Immediate code = null;

    if (!matchNextOpc(image, BitVector.valueOf("0100001", 2, 7))) {
      return null;
    }

    code = readNextImmediate(image, Type.CARD(19));

    if (!matchNextOpc(image, BitVector.valueOf("100000", 2, 6))) {
      return null;
    }

    return newResult(new wait(code));
  }
}
