/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.mmu.spec;

import ru.ispras.microtesk.basis.solver.integer.IntegerVariable;
import ru.ispras.microtesk.mmu.basis.MemoryOperation;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuSubsystem;
import java.util.Arrays;
import java.math.BigInteger;
import ru.ispras.microtesk.mmu.basis.BufferAccessEvent;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuAction;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuBinding;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuBufferAccess;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuCondition;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuConditionAtom;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuExpression;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuGuard;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuSegment;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuTransition;

/**
 * The {@code pmem} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class pmem {
  public final VA va = VA.get();
  private final PA pa = PA.get();

  public final IntegerVariable data;
  private final IntegerVariable isCached;
  private final IntegerVariable l2Bypass;
  private final IntegerVariable wordIndex;
  private final IntegerVariable line;
  private final L1.Entry l1Entry;
  private final L2.Entry l2Entry;
  private final MEM.Entry memEntry;

  public final MmuAction START;
  public final MmuAction STOP;

  private final MmuAction IF_READ;
  private final MmuAction ASSIGN_0;
  private final MmuAction ASSIGN_1;
  private final MmuAction ASSIGN_2;
  private final MmuAction ASSIGN_3;
  private final MmuAction BRANCH_0;
  private final MmuAction BRANCH_1;
  private final MmuAction ASSIGN_4;
  private final MmuAction ASSIGN_5;
  private final MmuAction JOIN_0;
  private final MmuAction BRANCH_2;
  private final MmuAction BRANCH_3;
  private final MmuAction BRANCH_4;
  private final MmuAction ASSIGN_6;
  private final MmuAction ASSIGN_7;
  private final MmuAction JOIN_1;
  private final MmuAction BRANCH_5;
  private final MmuAction ASSIGN_8;
  private final MmuAction ASSIGN_9;
  private final MmuAction ASSIGN_10;
  private final MmuAction ASSIGN_11;
  private final MmuAction JOIN_2;
  private final MmuAction BRANCH_6;
  private final MmuAction ASSIGN_12;
  private final MmuAction ASSIGN_13;
  private final MmuAction ASSIGN_14;
  private final MmuAction ASSIGN_15;
  private final MmuAction JOIN_3;
  private final MmuAction BRANCH_7;
  private final MmuAction ASSIGN_16;
  private final MmuAction ASSIGN_17;

  private final MmuAction IF_WRITE;
  private final MmuAction ASSIGN_18;
  private final MmuAction ASSIGN_19;
  private final MmuAction ASSIGN_20;
  private final MmuAction ASSIGN_21;
  private final MmuAction BRANCH_8;
  private final MmuAction BRANCH_9;
  private final MmuAction ASSIGN_22;
  private final MmuAction ASSIGN_23;
  private final MmuAction ASSIGN_24;
  private final MmuAction JOIN_4;
  private final MmuAction BRANCH_10;
  private final MmuAction BRANCH_11;
  private final MmuAction BRANCH_12;
  private final MmuAction ASSIGN_25;
  private final MmuAction ASSIGN_26;
  private final MmuAction ASSIGN_27;
  private final MmuAction JOIN_5;
  private final MmuAction BRANCH_13;
  private final MmuAction ASSIGN_28;
  private final MmuAction ASSIGN_29;
  private final MmuAction ASSIGN_30;
  private final MmuAction ASSIGN_31;
  private final MmuAction ASSIGN_32;
  private final MmuAction ASSIGN_33;
  private final MmuAction JOIN_6;
  private final MmuAction BRANCH_14;
  private final MmuAction ASSIGN_34;
  private final MmuAction ASSIGN_35;
  private final MmuAction ASSIGN_36;
  private final MmuAction ASSIGN_37;
  private final MmuAction ASSIGN_38;
  private final MmuAction ASSIGN_39;
  private final MmuAction JOIN_7;
  private final MmuAction BRANCH_15;
  private final MmuAction ASSIGN_40;
  private final MmuAction ASSIGN_41;
  private final MmuAction ASSIGN_42;

  protected pmem(final MmuSubsystem.Builder builder) {
    this(builder, "pmem");
  }

  private pmem(final MmuSubsystem.Builder builder, final String name) {
    builder.setName("pmem");

    this.data = new IntegerVariable(name + ".data", 64);
    builder.setDataVariable(data);

    this.isCached = new IntegerVariable(name + ".isCached", 1);
    builder.registerVariable(isCached);

    this.l2Bypass = new IntegerVariable(name + ".l2Bypass", 1);
    builder.registerVariable(l2Bypass);

    this.wordIndex = new IntegerVariable(name + ".wordIndex", 2);
    builder.registerVariable(wordIndex);

    this.line = new IntegerVariable(name + ".line", 256);
    builder.registerVariable(line);

    this.l1Entry = new L1.Entry(name + ".l1Entry");
    builder.registerVariable(l1Entry);

    this.l2Entry = new L2.Entry(name + ".l2Entry");
    builder.registerVariable(l2Entry);

    this.memEntry = new MEM.Entry(name + ".memEntry");
    builder.registerVariable(memEntry);


    this.START = new MmuAction(name + ".START");
    builder.registerAction(START);
    this.STOP = new MmuAction(name + ".STOP");
    builder.registerAction(STOP);

    this.IF_READ = new MmuAction(name + ".IF_READ");
    builder.registerAction(IF_READ);
    builder.registerTransition(new MmuTransition(START, IF_READ, new MmuGuard(MemoryOperation.LOAD)));
    final PA TMP_0 = new PA(name + ".TMP_0");
    TranslateAddress.Function call_0 = TranslateAddress.get().newCall(builder, TMP_0, va);
    builder.registerTransition(new MmuTransition(IF_READ, call_0.START));
    this.ASSIGN_0 = new MmuAction(name + ".ASSIGN_0", pa, TMP_0);
    builder.registerAction(ASSIGN_0);
    builder.registerTransition(new MmuTransition(call_0.STOP, ASSIGN_0));
    final IntegerVariable TMP_1 = new IntegerVariable(name + ".TMP_1", 1);
    IsCached.Function call_1 = IsCached.get().newCall(builder, TMP_1, pa.cca);
    builder.registerTransition(new MmuTransition(ASSIGN_0, call_1.START));
    this.ASSIGN_1 = new MmuAction(name + ".ASSIGN_1", new MmuBinding(isCached, TMP_1));
    builder.registerAction(ASSIGN_1);
    builder.registerTransition(new MmuTransition(call_1.STOP, ASSIGN_1));
    final IntegerVariable TMP_2 = new IntegerVariable(name + ".TMP_2", 1);
    IsSecondaryBypass.Function call_2 = IsSecondaryBypass.get().newCall(builder, TMP_2, pa.cca);
    builder.registerTransition(new MmuTransition(ASSIGN_1, call_2.START));
    this.ASSIGN_2 = new MmuAction(name + ".ASSIGN_2", new MmuBinding(l2Bypass, TMP_2));
    builder.registerAction(ASSIGN_2);
    builder.registerTransition(new MmuTransition(call_2.STOP, ASSIGN_2));
    this.ASSIGN_3 = new MmuAction(name + ".ASSIGN_3", new MmuBinding(wordIndex, pa.value.field(3, 4)));
    builder.registerAction(ASSIGN_3);
    builder.registerTransition(new MmuTransition(ASSIGN_2, ASSIGN_3));
    this.BRANCH_0 = new MmuAction(name + ".BRANCH_0");
    builder.registerAction(BRANCH_0);
    builder.registerTransition(new MmuTransition(ASSIGN_3, BRANCH_0, new MmuGuard(MmuConditionAtom.eq(isCached, new BigInteger("1", 10)))));
    this.BRANCH_1 = new MmuAction(name + ".BRANCH_1");
    builder.registerAction(BRANCH_1);
    builder.registerTransition(new MmuTransition(BRANCH_0, BRANCH_1, new MmuGuard(new MmuBufferAccess(L1.get(), BufferAccessEvent.HIT, L1.get().getAddress(), L1.get(), pa))));
    this.ASSIGN_4 = new MmuAction(name + ".ASSIGN_4", new MmuBufferAccess(L1.get(), BufferAccessEvent.READ, L1.get().getAddress(), L1.get(), pa), l1Entry, L1.get());
    builder.registerAction(ASSIGN_4);
    builder.registerTransition(new MmuTransition(BRANCH_1, ASSIGN_4));
    this.ASSIGN_5 = new MmuAction(name + ".ASSIGN_5", new MmuBinding(line, l1Entry.DATA));
    builder.registerAction(ASSIGN_5);
    builder.registerTransition(new MmuTransition(ASSIGN_4, ASSIGN_5));
    this.JOIN_0 = new MmuAction(name + ".JOIN_0");
    builder.registerAction(JOIN_0);
    builder.registerTransition(new MmuTransition(ASSIGN_5, JOIN_0));
    this.BRANCH_2 = new MmuAction(name + ".BRANCH_2");
    builder.registerAction(BRANCH_2);
    builder.registerTransition(new MmuTransition(BRANCH_0, BRANCH_2, new MmuGuard(new MmuBufferAccess(L1.get(), BufferAccessEvent.MISS, L1.get().getAddress(), L1.get(), pa))));
    this.BRANCH_3 = new MmuAction(name + ".BRANCH_3");
    builder.registerAction(BRANCH_3);
    builder.registerTransition(new MmuTransition(BRANCH_2, BRANCH_3, new MmuGuard(MmuConditionAtom.eq(l2Bypass, new BigInteger("0", 10)))));
    this.BRANCH_4 = new MmuAction(name + ".BRANCH_4");
    builder.registerAction(BRANCH_4);
    builder.registerTransition(new MmuTransition(BRANCH_3, BRANCH_4, new MmuGuard(new MmuBufferAccess(L2.get(), BufferAccessEvent.HIT, L2.get().getAddress(), L2.get(), pa))));
    this.ASSIGN_6 = new MmuAction(name + ".ASSIGN_6", new MmuBufferAccess(L2.get(), BufferAccessEvent.READ, L2.get().getAddress(), L2.get(), pa), l2Entry, L2.get());
    builder.registerAction(ASSIGN_6);
    builder.registerTransition(new MmuTransition(BRANCH_4, ASSIGN_6));
    this.ASSIGN_7 = new MmuAction(name + ".ASSIGN_7", new MmuBinding(line, l2Entry.DATA));
    builder.registerAction(ASSIGN_7);
    builder.registerTransition(new MmuTransition(ASSIGN_6, ASSIGN_7));
    this.JOIN_1 = new MmuAction(name + ".JOIN_1");
    builder.registerAction(JOIN_1);
    builder.registerTransition(new MmuTransition(ASSIGN_7, JOIN_1));
    this.BRANCH_5 = new MmuAction(name + ".BRANCH_5");
    builder.registerAction(BRANCH_5);
    builder.registerTransition(new MmuTransition(BRANCH_3, BRANCH_5, new MmuGuard(new MmuBufferAccess(L2.get(), BufferAccessEvent.MISS, L2.get().getAddress(), L2.get(), pa))));
    this.ASSIGN_8 = new MmuAction(name + ".ASSIGN_8", new MmuBufferAccess(MEM.get(), BufferAccessEvent.READ, MEM.get().getAddress(), MEM.get(), pa), new MmuBinding(line, MEM.get().DATA));
    builder.registerAction(ASSIGN_8);
    builder.registerTransition(new MmuTransition(BRANCH_5, ASSIGN_8));
    this.ASSIGN_9 = new MmuAction(name + ".ASSIGN_9", new MmuBinding(l2Entry.TAG, pa.value.field(17, 35)));
    builder.registerAction(ASSIGN_9);
    builder.registerTransition(new MmuTransition(ASSIGN_8, ASSIGN_9));
    this.ASSIGN_10 = new MmuAction(name + ".ASSIGN_10", new MmuBinding(l2Entry.DATA, line));
    builder.registerAction(ASSIGN_10);
    builder.registerTransition(new MmuTransition(ASSIGN_9, ASSIGN_10));
    this.ASSIGN_11 = new MmuAction(name + ".ASSIGN_11", new MmuBufferAccess(L2.get(), BufferAccessEvent.WRITE, L2.get().getAddress(), L2.get(), null));
    builder.registerAction(ASSIGN_11);
    builder.registerTransition(new MmuTransition(ASSIGN_10, ASSIGN_11));
    builder.registerTransition(new MmuTransition(ASSIGN_11, JOIN_1));
    this.JOIN_2 = new MmuAction(name + ".JOIN_2");
    builder.registerAction(JOIN_2);
    builder.registerTransition(new MmuTransition(JOIN_1, JOIN_2));
    this.BRANCH_6 = new MmuAction(name + ".BRANCH_6");
    builder.registerAction(BRANCH_6);
    builder.registerTransition(new MmuTransition(BRANCH_2, BRANCH_6, new MmuGuard(MmuConditionAtom.neq(l2Bypass, new BigInteger("0", 10)))));
    this.ASSIGN_12 = new MmuAction(name + ".ASSIGN_12", new MmuBufferAccess(MEM.get(), BufferAccessEvent.READ, MEM.get().getAddress(), MEM.get(), pa), new MmuBinding(line, MEM.get().DATA));
    builder.registerAction(ASSIGN_12);
    builder.registerTransition(new MmuTransition(BRANCH_6, ASSIGN_12));
    builder.registerTransition(new MmuTransition(ASSIGN_12, JOIN_2));
    this.ASSIGN_13 = new MmuAction(name + ".ASSIGN_13", new MmuBinding(l1Entry.TAG, pa.value.field(12, 35)));
    builder.registerAction(ASSIGN_13);
    builder.registerTransition(new MmuTransition(JOIN_2, ASSIGN_13));
    this.ASSIGN_14 = new MmuAction(name + ".ASSIGN_14", new MmuBinding(l1Entry.DATA, line));
    builder.registerAction(ASSIGN_14);
    builder.registerTransition(new MmuTransition(ASSIGN_13, ASSIGN_14));
    this.ASSIGN_15 = new MmuAction(name + ".ASSIGN_15", new MmuBufferAccess(L1.get(), BufferAccessEvent.WRITE, L1.get().getAddress(), L1.get(), null));
    builder.registerAction(ASSIGN_15);
    builder.registerTransition(new MmuTransition(ASSIGN_14, ASSIGN_15));
    builder.registerTransition(new MmuTransition(ASSIGN_15, JOIN_0));
    this.JOIN_3 = new MmuAction(name + ".JOIN_3");
    builder.registerAction(JOIN_3);
    builder.registerTransition(new MmuTransition(JOIN_0, JOIN_3));
    this.BRANCH_7 = new MmuAction(name + ".BRANCH_7");
    builder.registerAction(BRANCH_7);
    builder.registerTransition(new MmuTransition(ASSIGN_3, BRANCH_7, new MmuGuard(MmuConditionAtom.neq(isCached, new BigInteger("1", 10)))));
    this.ASSIGN_16 = new MmuAction(name + ".ASSIGN_16", new MmuBufferAccess(MEM.get(), BufferAccessEvent.READ, MEM.get().getAddress(), MEM.get(), pa), new MmuBinding(line, MEM.get().DATA));
    builder.registerAction(ASSIGN_16);
    builder.registerTransition(new MmuTransition(BRANCH_7, ASSIGN_16));
    builder.registerTransition(new MmuTransition(ASSIGN_16, JOIN_3));
    final IntegerVariable TMP_3 = new IntegerVariable(name + ".TMP_3", 64);
    getWordFromLine.Function call_3 = getWordFromLine.get().newCall(builder, TMP_3, wordIndex, line);
    builder.registerTransition(new MmuTransition(JOIN_3, call_3.START));
    this.ASSIGN_17 = new MmuAction(name + ".ASSIGN_17", new MmuBinding(data, TMP_3));
    builder.registerAction(ASSIGN_17);
    builder.registerTransition(new MmuTransition(call_3.STOP, ASSIGN_17));
    builder.registerTransition(new MmuTransition(ASSIGN_17, STOP));

    this.IF_WRITE = new MmuAction(name + ".IF_WRITE");
    builder.registerAction(IF_WRITE);
    builder.registerTransition(new MmuTransition(START, IF_WRITE, new MmuGuard(MemoryOperation.STORE)));
    final PA TMP_4 = new PA(name + ".TMP_4");
    TranslateAddress.Function call_4 = TranslateAddress.get().newCall(builder, TMP_4, va);
    builder.registerTransition(new MmuTransition(IF_WRITE, call_4.START));
    this.ASSIGN_18 = new MmuAction(name + ".ASSIGN_18", pa, TMP_4);
    builder.registerAction(ASSIGN_18);
    builder.registerTransition(new MmuTransition(call_4.STOP, ASSIGN_18));
    final IntegerVariable TMP_5 = new IntegerVariable(name + ".TMP_5", 1);
    IsCached.Function call_5 = IsCached.get().newCall(builder, TMP_5, pa.cca);
    builder.registerTransition(new MmuTransition(ASSIGN_18, call_5.START));
    this.ASSIGN_19 = new MmuAction(name + ".ASSIGN_19", new MmuBinding(isCached, TMP_5));
    builder.registerAction(ASSIGN_19);
    builder.registerTransition(new MmuTransition(call_5.STOP, ASSIGN_19));
    final IntegerVariable TMP_6 = new IntegerVariable(name + ".TMP_6", 1);
    IsSecondaryBypass.Function call_6 = IsSecondaryBypass.get().newCall(builder, TMP_6, pa.cca);
    builder.registerTransition(new MmuTransition(ASSIGN_19, call_6.START));
    this.ASSIGN_20 = new MmuAction(name + ".ASSIGN_20", new MmuBinding(l2Bypass, TMP_6));
    builder.registerAction(ASSIGN_20);
    builder.registerTransition(new MmuTransition(call_6.STOP, ASSIGN_20));
    this.ASSIGN_21 = new MmuAction(name + ".ASSIGN_21", new MmuBinding(wordIndex, pa.value.field(3, 4)));
    builder.registerAction(ASSIGN_21);
    builder.registerTransition(new MmuTransition(ASSIGN_20, ASSIGN_21));
    this.BRANCH_8 = new MmuAction(name + ".BRANCH_8");
    builder.registerAction(BRANCH_8);
    builder.registerTransition(new MmuTransition(ASSIGN_21, BRANCH_8, new MmuGuard(MmuConditionAtom.eq(isCached, new BigInteger("1", 10)))));
    this.BRANCH_9 = new MmuAction(name + ".BRANCH_9");
    builder.registerAction(BRANCH_9);
    builder.registerTransition(new MmuTransition(BRANCH_8, BRANCH_9, new MmuGuard(new MmuBufferAccess(L1.get(), BufferAccessEvent.HIT, L1.get().getAddress(), L1.get(), pa))));
    this.ASSIGN_22 = new MmuAction(name + ".ASSIGN_22", new MmuBufferAccess(L1.get(), BufferAccessEvent.READ, L1.get().getAddress(), L1.get(), pa), l1Entry, L1.get());
    builder.registerAction(ASSIGN_22);
    builder.registerTransition(new MmuTransition(BRANCH_9, ASSIGN_22));
    final IntegerVariable TMP_7 = new IntegerVariable(name + ".TMP_7", 256);
    putWordIntoLine.Function call_7 = putWordIntoLine.get().newCall(builder, TMP_7, wordIndex, l1Entry.DATA, data);
    builder.registerTransition(new MmuTransition(ASSIGN_22, call_7.START));
    this.ASSIGN_23 = new MmuAction(name + ".ASSIGN_23", new MmuBinding(l1Entry.DATA, TMP_7));
    builder.registerAction(ASSIGN_23);
    builder.registerTransition(new MmuTransition(call_7.STOP, ASSIGN_23));
    this.ASSIGN_24 = new MmuAction(name + ".ASSIGN_24", new MmuBufferAccess(L1.get(), BufferAccessEvent.WRITE, L1.get().getAddress(), L1.get(), null));
    builder.registerAction(ASSIGN_24);
    builder.registerTransition(new MmuTransition(ASSIGN_23, ASSIGN_24));
    this.JOIN_4 = new MmuAction(name + ".JOIN_4");
    builder.registerAction(JOIN_4);
    builder.registerTransition(new MmuTransition(ASSIGN_24, JOIN_4));
    this.BRANCH_10 = new MmuAction(name + ".BRANCH_10");
    builder.registerAction(BRANCH_10);
    builder.registerTransition(new MmuTransition(BRANCH_8, BRANCH_10, new MmuGuard(new MmuBufferAccess(L1.get(), BufferAccessEvent.MISS, L1.get().getAddress(), L1.get(), pa))));
    this.BRANCH_11 = new MmuAction(name + ".BRANCH_11");
    builder.registerAction(BRANCH_11);
    builder.registerTransition(new MmuTransition(BRANCH_10, BRANCH_11, new MmuGuard(MmuConditionAtom.eq(l2Bypass, new BigInteger("0", 10)))));
    this.BRANCH_12 = new MmuAction(name + ".BRANCH_12");
    builder.registerAction(BRANCH_12);
    builder.registerTransition(new MmuTransition(BRANCH_11, BRANCH_12, new MmuGuard(new MmuBufferAccess(L2.get(), BufferAccessEvent.HIT, L2.get().getAddress(), L2.get(), pa))));
    this.ASSIGN_25 = new MmuAction(name + ".ASSIGN_25", new MmuBufferAccess(L2.get(), BufferAccessEvent.READ, L2.get().getAddress(), L2.get(), pa), l2Entry, L2.get());
    builder.registerAction(ASSIGN_25);
    builder.registerTransition(new MmuTransition(BRANCH_12, ASSIGN_25));
    final IntegerVariable TMP_8 = new IntegerVariable(name + ".TMP_8", 256);
    putWordIntoLine.Function call_8 = putWordIntoLine.get().newCall(builder, TMP_8, wordIndex, l2Entry.DATA, data);
    builder.registerTransition(new MmuTransition(ASSIGN_25, call_8.START));
    this.ASSIGN_26 = new MmuAction(name + ".ASSIGN_26", new MmuBinding(l2Entry.DATA, TMP_8));
    builder.registerAction(ASSIGN_26);
    builder.registerTransition(new MmuTransition(call_8.STOP, ASSIGN_26));
    this.ASSIGN_27 = new MmuAction(name + ".ASSIGN_27", new MmuBufferAccess(L2.get(), BufferAccessEvent.WRITE, L2.get().getAddress(), L2.get(), null));
    builder.registerAction(ASSIGN_27);
    builder.registerTransition(new MmuTransition(ASSIGN_26, ASSIGN_27));
    this.JOIN_5 = new MmuAction(name + ".JOIN_5");
    builder.registerAction(JOIN_5);
    builder.registerTransition(new MmuTransition(ASSIGN_27, JOIN_5));
    this.BRANCH_13 = new MmuAction(name + ".BRANCH_13");
    builder.registerAction(BRANCH_13);
    builder.registerTransition(new MmuTransition(BRANCH_11, BRANCH_13, new MmuGuard(new MmuBufferAccess(L2.get(), BufferAccessEvent.MISS, L2.get().getAddress(), L2.get(), pa))));
    this.ASSIGN_28 = new MmuAction(name + ".ASSIGN_28", new MmuBufferAccess(MEM.get(), BufferAccessEvent.READ, MEM.get().getAddress(), MEM.get(), pa), memEntry, MEM.get());
    builder.registerAction(ASSIGN_28);
    builder.registerTransition(new MmuTransition(BRANCH_13, ASSIGN_28));
    final IntegerVariable TMP_9 = new IntegerVariable(name + ".TMP_9", 256);
    putWordIntoLine.Function call_9 = putWordIntoLine.get().newCall(builder, TMP_9, wordIndex, memEntry.DATA, data);
    builder.registerTransition(new MmuTransition(ASSIGN_28, call_9.START));
    this.ASSIGN_29 = new MmuAction(name + ".ASSIGN_29", new MmuBinding(memEntry.DATA, TMP_9));
    builder.registerAction(ASSIGN_29);
    builder.registerTransition(new MmuTransition(call_9.STOP, ASSIGN_29));
    this.ASSIGN_30 = new MmuAction(name + ".ASSIGN_30", new MmuBufferAccess(MEM.get(), BufferAccessEvent.WRITE, MEM.get().getAddress(), MEM.get(), null));
    builder.registerAction(ASSIGN_30);
    builder.registerTransition(new MmuTransition(ASSIGN_29, ASSIGN_30));
    this.ASSIGN_31 = new MmuAction(name + ".ASSIGN_31", new MmuBinding(l2Entry.TAG, pa.value.field(17, 35)));
    builder.registerAction(ASSIGN_31);
    builder.registerTransition(new MmuTransition(ASSIGN_30, ASSIGN_31));
    final IntegerVariable TMP_10 = new IntegerVariable(name + ".TMP_10", 256);
    putWordIntoLine.Function call_10 = putWordIntoLine.get().newCall(builder, TMP_10, wordIndex, l2Entry.DATA, data);
    builder.registerTransition(new MmuTransition(ASSIGN_31, call_10.START));
    this.ASSIGN_32 = new MmuAction(name + ".ASSIGN_32", new MmuBinding(l2Entry.DATA, TMP_10));
    builder.registerAction(ASSIGN_32);
    builder.registerTransition(new MmuTransition(call_10.STOP, ASSIGN_32));
    this.ASSIGN_33 = new MmuAction(name + ".ASSIGN_33", new MmuBufferAccess(L2.get(), BufferAccessEvent.WRITE, L2.get().getAddress(), L2.get(), null));
    builder.registerAction(ASSIGN_33);
    builder.registerTransition(new MmuTransition(ASSIGN_32, ASSIGN_33));
    builder.registerTransition(new MmuTransition(ASSIGN_33, JOIN_5));
    this.JOIN_6 = new MmuAction(name + ".JOIN_6");
    builder.registerAction(JOIN_6);
    builder.registerTransition(new MmuTransition(JOIN_5, JOIN_6));
    this.BRANCH_14 = new MmuAction(name + ".BRANCH_14");
    builder.registerAction(BRANCH_14);
    builder.registerTransition(new MmuTransition(BRANCH_10, BRANCH_14, new MmuGuard(MmuConditionAtom.neq(l2Bypass, new BigInteger("0", 10)))));
    this.ASSIGN_34 = new MmuAction(name + ".ASSIGN_34", new MmuBufferAccess(MEM.get(), BufferAccessEvent.READ, MEM.get().getAddress(), MEM.get(), pa), memEntry, MEM.get());
    builder.registerAction(ASSIGN_34);
    builder.registerTransition(new MmuTransition(BRANCH_14, ASSIGN_34));
    final IntegerVariable TMP_11 = new IntegerVariable(name + ".TMP_11", 256);
    putWordIntoLine.Function call_11 = putWordIntoLine.get().newCall(builder, TMP_11, wordIndex, memEntry.DATA, data);
    builder.registerTransition(new MmuTransition(ASSIGN_34, call_11.START));
    this.ASSIGN_35 = new MmuAction(name + ".ASSIGN_35", new MmuBinding(memEntry.DATA, TMP_11));
    builder.registerAction(ASSIGN_35);
    builder.registerTransition(new MmuTransition(call_11.STOP, ASSIGN_35));
    this.ASSIGN_36 = new MmuAction(name + ".ASSIGN_36", new MmuBufferAccess(MEM.get(), BufferAccessEvent.WRITE, MEM.get().getAddress(), MEM.get(), null));
    builder.registerAction(ASSIGN_36);
    builder.registerTransition(new MmuTransition(ASSIGN_35, ASSIGN_36));
    builder.registerTransition(new MmuTransition(ASSIGN_36, JOIN_6));
    this.ASSIGN_37 = new MmuAction(name + ".ASSIGN_37", new MmuBinding(l1Entry.TAG, pa.value.field(12, 35)));
    builder.registerAction(ASSIGN_37);
    builder.registerTransition(new MmuTransition(JOIN_6, ASSIGN_37));
    final IntegerVariable TMP_12 = new IntegerVariable(name + ".TMP_12", 256);
    putWordIntoLine.Function call_12 = putWordIntoLine.get().newCall(builder, TMP_12, wordIndex, l1Entry.DATA, data);
    builder.registerTransition(new MmuTransition(ASSIGN_37, call_12.START));
    this.ASSIGN_38 = new MmuAction(name + ".ASSIGN_38", new MmuBinding(l1Entry.DATA, TMP_12));
    builder.registerAction(ASSIGN_38);
    builder.registerTransition(new MmuTransition(call_12.STOP, ASSIGN_38));
    this.ASSIGN_39 = new MmuAction(name + ".ASSIGN_39", new MmuBufferAccess(L1.get(), BufferAccessEvent.WRITE, L1.get().getAddress(), L1.get(), null));
    builder.registerAction(ASSIGN_39);
    builder.registerTransition(new MmuTransition(ASSIGN_38, ASSIGN_39));
    builder.registerTransition(new MmuTransition(ASSIGN_39, JOIN_4));
    this.JOIN_7 = new MmuAction(name + ".JOIN_7");
    builder.registerAction(JOIN_7);
    builder.registerTransition(new MmuTransition(JOIN_4, JOIN_7));
    this.BRANCH_15 = new MmuAction(name + ".BRANCH_15");
    builder.registerAction(BRANCH_15);
    builder.registerTransition(new MmuTransition(ASSIGN_21, BRANCH_15, new MmuGuard(MmuConditionAtom.neq(isCached, new BigInteger("1", 10)))));
    this.ASSIGN_40 = new MmuAction(name + ".ASSIGN_40", new MmuBufferAccess(MEM.get(), BufferAccessEvent.READ, MEM.get().getAddress(), MEM.get(), pa), memEntry, MEM.get());
    builder.registerAction(ASSIGN_40);
    builder.registerTransition(new MmuTransition(BRANCH_15, ASSIGN_40));
    final IntegerVariable TMP_13 = new IntegerVariable(name + ".TMP_13", 256);
    putWordIntoLine.Function call_13 = putWordIntoLine.get().newCall(builder, TMP_13, wordIndex, memEntry.DATA, data);
    builder.registerTransition(new MmuTransition(ASSIGN_40, call_13.START));
    this.ASSIGN_41 = new MmuAction(name + ".ASSIGN_41", new MmuBinding(memEntry.DATA, TMP_13));
    builder.registerAction(ASSIGN_41);
    builder.registerTransition(new MmuTransition(call_13.STOP, ASSIGN_41));
    this.ASSIGN_42 = new MmuAction(name + ".ASSIGN_42", new MmuBufferAccess(MEM.get(), BufferAccessEvent.WRITE, MEM.get().getAddress(), MEM.get(), null));
    builder.registerAction(ASSIGN_42);
    builder.registerTransition(new MmuTransition(ASSIGN_41, ASSIGN_42));
    builder.registerTransition(new MmuTransition(ASSIGN_42, JOIN_7));
    builder.registerTransition(new MmuTransition(JOIN_7, STOP));
  }
}
