/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.mips64.mode.*;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class C_cond extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "C_cond",
          C_cond.class,
          null
          );
      addArgument("cond_value", FPU_COND_TYPE.INFO);
      addArgument("op_fmt", FMT_FORMAT.INFO);
      addArgument("cc", Type.CARD(3));
      addArgument("fs", FR.INFO);
      addArgument("ft", FR.INFO);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final IsaPrimitive cond_value = (IsaPrimitive) getArgument("cond_value", args);
      final IsaPrimitive op_fmt = (IsaPrimitive) getArgument("op_fmt", args);
      final Immediate cc = (Immediate) getArgument("cc", args);
      final FR fs = (FR) getArgument("fs", args);
      final FR ft = (FR) getArgument("ft", args);

      return new C_cond(cond_value, op_fmt, cc, fs, ft);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "C_cond",
          instruction.class,
          null
          );
      addArgument("cond_value", FPU_COND_TYPE.INFO);
      addArgument("op_fmt", FMT_FORMAT.INFO);
      addArgument("cc", Type.CARD(3));
      addArgument("fs", FR.INFO);
      addArgument("ft", FR.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final IsaPrimitive cond_value = (IsaPrimitive) getArgument("cond_value", args);
      final IsaPrimitive op_fmt = (IsaPrimitive) getArgument("op_fmt", args);
      final Immediate cc = (Immediate) getArgument("cc", args);
      final FR fs = (FR) getArgument("fs", args);
      final FR ft = (FR) getArgument("ft", args);

      return new instruction(
        new C_cond(
          cond_value,
          op_fmt,
          cc,
          fs,
          ft
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final IsaPrimitive cond_value;
  public final IsaPrimitive op_fmt;
  public final Immediate cc;
  public final FR fs;
  public final FR ft;

  public C_cond(final IsaPrimitive cond_value, final IsaPrimitive op_fmt, final Immediate cc, final FR fs, final FR ft) {
    assert FPU_COND_TYPE.INFO.isSupported(cond_value);
    assert FMT_FORMAT.INFO.isSupported(op_fmt);
    assert Type.CARD(3).equals(cc.getType());
    assert FR.INFO.isSupported(fs);
    assert FR.INFO.isSupported(ft);

    this.cond_value = cond_value;
    this.op_fmt = op_fmt;
    this.cc = cc;
    this.fs = fs;
    this.ft = ft;

    addArgument("cond_value", cond_value);
    addArgument("op_fmt", op_fmt);
    addArgument("cc", cc);
    addArgument("fs", fs);
    addArgument("ft", ft);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("c.%s.%s %d, %s, %s", cond_value.syntax(vars__), op_fmt.syntax(vars__), cc.access().load().bigIntegerValue(), fs.syntax(vars__), ft.syntax(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("010001%5s%5s%5s%3s0011%4s", op_fmt.image(vars__), ft.image(vars__), fs.image(vars__), cc.access().load().toString(), cond_value.image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    vars__.temp_fp_d.access().store(Data.intToFloat(FLOAT64, fs.access(pe__, vars__).bitField(63, 0).load()));
    vars__.temp_fp_d2.access().store(Data.intToFloat(FLOAT64, ft.access(pe__, vars__).bitField(63, 0).load()));
    if ((((vars__.temp_fp_d.access().load().isNan() || vars__.temp_fp_d2.access().load().isNan()) || vars__.temp_fp_d.access().load().isSignalingNan()) || vars__.temp_fp_d2.access().load().isSignalingNan())) {
      vars__.c_cond_less.access().store(Data.valueOf(BIT, 0x0));
      vars__.c_cond_equal.access().store(Data.valueOf(BIT, 0x0));
      vars__.c_cond_unordered.access().store(Data.valueOf(BIT, 0x1));
      cond_value.execute(pe__, vars__);
      if (((vars__.temp_fp_d.access().load().isSignalingNan() || vars__.temp_fp_d2.access().load().isSignalingNan()) || (vars__.fpu_cond.access().bitField(3, 3).load().equals(Data.valueOf(Type.CARD(1), 0x1)) && vars__.temp_fp_d.access().load().isNan() || vars__.temp_fp_d2.access().load().isNan()))) {
        Execution.exception("InvalidOperation");
      }
    } else {
    }
  }
}