/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class FPConditionCode extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "FPConditionCode",
          FPConditionCode.class,
          null
          );
      addArgument("cc", Type.CARD(3));}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate cc = (Immediate) getArgument("cc", args);

      return new FPConditionCode(cc);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final Immediate cc;

  public FPConditionCode(final Immediate cc) {
    assert Type.CARD(3).equals(cc.getType());

    this.cc = cc;

    addArgument("cc", cc);
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    if (cc.access().load().equals(Data.valueOf(Type.CARD(3), 0x0))) {
      pe__.FPConditionCode_value.access().store(pe__.FCSR_FCC_0.access().load());
    } else {
      pe__.FPConditionCode_value.access().store(pe__.FCSR_FCC_1_7.access().bitField(cc.access().load(), cc.access().load()).load());
    }
  }
}