/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.mips64.mode.*;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class cvtl_fmt extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "cvtl_fmt",
          cvtl_fmt.class,
          null
          );
      addArgument("op_fmt", FMT_FORMAT.INFO);
      addArgument("fd", FR.INFO);
      addArgument("fs", FR.INFO);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final IsaPrimitive op_fmt = (IsaPrimitive) getArgument("op_fmt", args);
      final FR fd = (FR) getArgument("fd", args);
      final FR fs = (FR) getArgument("fs", args);

      return new cvtl_fmt(op_fmt, fd, fs);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "cvtl_fmt",
          instruction.class,
          null
          );
      addArgument("op_fmt", FMT_FORMAT.INFO);
      addArgument("fd", FR.INFO);
      addArgument("fs", FR.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final IsaPrimitive op_fmt = (IsaPrimitive) getArgument("op_fmt", args);
      final FR fd = (FR) getArgument("fd", args);
      final FR fs = (FR) getArgument("fs", args);

      return new instruction(
        new cvtl_fmt(
          op_fmt,
          fd,
          fs
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final IsaPrimitive op_fmt;
  public final FR fd;
  public final FR fs;

  public cvtl_fmt(final IsaPrimitive op_fmt, final FR fd, final FR fs) {
    assert FMT_FORMAT.INFO.isSupported(op_fmt);
    assert FR.INFO.isSupported(fd);
    assert FR.INFO.isSupported(fs);

    this.op_fmt = op_fmt;
    this.fd = fd;
    this.fs = fs;

    addArgument("op_fmt", op_fmt);
    addArgument("fd", fd);
    addArgument("fs", fs);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("cvt.l.%s %s, %s", op_fmt.syntax(vars__), fd.syntax(vars__), fs.syntax(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("010001%5s00000%5s%5s100101", op_fmt.image(vars__), fs.image(vars__), fd.image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    if (vars__.fmt_fpu.access().load().equals(Data.valueOf(Type.CARD(5), 0x10))) {
      vars__.temp_fp_s.access().bitField(31, 0).store(fs.access(pe__, vars__).bitField(31, 0).load());
      vars__.tempL.access().store(Data.floatToInt(LONG, vars__.temp_fp_s.access().load()));
    } else if (vars__.fmt_fpu.access().load().equals(Data.valueOf(Type.CARD(5), 0x11))) {
      vars__.temp_fp_d.access().bitField(63, 0).store(fs.access(pe__, vars__).bitField(63, 0).load());
      vars__.tempL.access().store(Data.floatToInt(LONG, vars__.temp_fp_d.access().load()));
    } else {
      Execution.unpredicted();
    }
    fd.access(pe__, vars__).bitField(63, 0).store(vars__.tempL.access().bitField(63, 0).load());
  }
}