/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.mips64.mode.*;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class dmtc2 extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "dmtc2",
          dmtc2.class,
          null
          );
      addArgument("rt", R.INFO);
      addArgument("rd", R.INFO);
      addArgument("sel", Type.CARD(11));
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R rt = (R) getArgument("rt", args);
      final R rd = (R) getArgument("rd", args);
      final Immediate sel = (Immediate) getArgument("sel", args);

      return new dmtc2(rt, rd, sel);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "dmtc2",
          instruction.class,
          null
          );
      addArgument("rt", R.INFO);
      addArgument("rd", R.INFO);
      addArgument("sel", Type.CARD(11));
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R rt = (R) getArgument("rt", args);
      final R rd = (R) getArgument("rd", args);
      final Immediate sel = (Immediate) getArgument("sel", args);

      return new instruction(
        new dmtc2(
          rt,
          rd,
          sel
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final R rt;
  public final R rd;
  public final Immediate sel;

  public dmtc2(final R rt, final R rd, final Immediate sel) {
    assert R.INFO.isSupported(rt);
    assert R.INFO.isSupported(rd);
    assert Type.CARD(11).equals(sel.getType());

    this.rt = rt;
    this.rd = rd;
    this.sel = sel;

    addArgument("rt", rt);
    addArgument("rd", rd);
    addArgument("sel", sel);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("dmtc2 %s, %s, %d", rt.syntax(vars__), rd.syntax(vars__), sel.access().load().bigIntegerValue());
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("01001000101%5s%5s%11s", rt.image(vars__), rd.image(vars__), sel.access().load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
  }
}