/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.mips64.mode.*;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class lui extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "lui",
          lui.class,
          null
          );
      addArgument("rt", R.INFO);
      addArgument("immediate", HWORD);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R rt = (R) getArgument("rt", args);
      final Immediate immediate = (Immediate) getArgument("immediate", args);

      return new lui(rt, immediate);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "lui",
          instruction.class,
          null
          );
      addArgument("rt", R.INFO);
      addArgument("immediate", HWORD);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R rt = (R) getArgument("rt", args);
      final Immediate immediate = (Immediate) getArgument("immediate", args);

      return new instruction(
        new lui(
          rt,
          immediate
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final R rt;
  public final Immediate immediate;

  public lui(final R rt, final Immediate immediate) {
    assert R.INFO.isSupported(rt);
    assert HWORD.equals(immediate.getType());

    this.rt = rt;
    this.immediate = immediate;

    addArgument("rt", rt);
    addArgument("immediate", immediate);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("lui %s, 0x%x", rt.syntax(vars__), immediate.access().load().bigIntegerValue(false));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("00111100000%5s%16s", rt.image(vars__), immediate.access().load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    rt.access(pe__, vars__).store(Data.signExtend(DWORD, immediate.access().load()).shiftLeft(Data.valueOf(DWORD, 0x10)));
  }
}