/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.mips64.mode.*;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class maddu extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "maddu",
          maddu.class,
          null
          );
      addArgument("rs", R.INFO);
      addArgument("rt", R.INFO);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R rs = (R) getArgument("rs", args);
      final R rt = (R) getArgument("rt", args);

      return new maddu(rs, rt);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "maddu",
          instruction.class,
          null
          );
      addArgument("rs", R.INFO);
      addArgument("rt", R.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R rs = (R) getArgument("rs", args);
      final R rt = (R) getArgument("rt", args);

      return new instruction(
        new maddu(
          rs,
          rt
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final R rs;
  public final R rt;

  public maddu(final R rs, final R rt) {
    assert R.INFO.isSupported(rs);
    assert R.INFO.isSupported(rt);

    this.rs = rs;
    this.rt = rt;

    addArgument("rs", rs);
    addArgument("rt", rt);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("maddu %s, %s", rs.syntax(vars__), rt.syntax(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("011100%5s%5s0000000000000001", rs.image(vars__), rt.image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    new check_sign_extend_values(rs, rt).execute(pe__, vars__);
    new mul_unsigned_words(new Immediate(rs.access(pe__, vars__).bitField(31, 0)), new Immediate(rt.access(pe__, vars__).bitField(31, 0))).execute(pe__, vars__);
    vars__.temp64.access().store(Location.concat(pe__.HI.access().bitField(31, 0), pe__.LO.access().bitField(31, 0)).load().add(vars__.temp64.access().load()));
    pe__.HI.access().store(Data.signExtend(DWORD, vars__.temp64.access().bitField(63, 32).load()));
    pe__.LO.access().store(Data.signExtend(DWORD, vars__.temp64.access().bitField(31, 0).load()));
  }
}