/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.mips64.mode.*;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class movn_fmt extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "movn_fmt",
          movn_fmt.class,
          null
          );
      addArgument("op_fmt", FMT_FORMAT.INFO);
      addArgument("fd", FR.INFO);
      addArgument("fs", FR.INFO);
      addArgument("rt", R.INFO);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final IsaPrimitive op_fmt = (IsaPrimitive) getArgument("op_fmt", args);
      final FR fd = (FR) getArgument("fd", args);
      final FR fs = (FR) getArgument("fs", args);
      final R rt = (R) getArgument("rt", args);

      return new movn_fmt(op_fmt, fd, fs, rt);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "movn_fmt",
          instruction.class,
          null
          );
      addArgument("op_fmt", FMT_FORMAT.INFO);
      addArgument("fd", FR.INFO);
      addArgument("fs", FR.INFO);
      addArgument("rt", R.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final IsaPrimitive op_fmt = (IsaPrimitive) getArgument("op_fmt", args);
      final FR fd = (FR) getArgument("fd", args);
      final FR fs = (FR) getArgument("fs", args);
      final R rt = (R) getArgument("rt", args);

      return new instruction(
        new movn_fmt(
          op_fmt,
          fd,
          fs,
          rt
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final IsaPrimitive op_fmt;
  public final FR fd;
  public final FR fs;
  public final R rt;

  public movn_fmt(final IsaPrimitive op_fmt, final FR fd, final FR fs, final R rt) {
    assert FMT_FORMAT.INFO.isSupported(op_fmt);
    assert FR.INFO.isSupported(fd);
    assert FR.INFO.isSupported(fs);
    assert R.INFO.isSupported(rt);

    this.op_fmt = op_fmt;
    this.fd = fd;
    this.fs = fs;
    this.rt = rt;

    addArgument("op_fmt", op_fmt);
    addArgument("fd", fd);
    addArgument("fs", fs);
    addArgument("rt", rt);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("movn.%s %s, %s, %s", op_fmt.syntax(vars__), fd.syntax(vars__), fs.syntax(vars__), rt.syntax(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("010001%5s%5s%5s%5s010011", op_fmt.image(vars__), rt.image(vars__), fs.image(vars__), fd.image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    if (!rt.access(pe__, vars__).load().equals(Data.valueOf(DWORD, 0x0))) {
      if (vars__.fmt_fpu.access().load().equals(Data.valueOf(Type.CARD(5), 0x10))) {
        fd.access(pe__, vars__).bitField(31, 31).store(fs.access(pe__, vars__).bitField(31, 31).load());
      } else if ((vars__.fmt_fpu.access().load().equals(Data.valueOf(Type.CARD(5), 0x11)) || vars__.fmt_fpu.access().load().equals(Data.valueOf(Type.CARD(5), 0x16)))) {
        fd.access(pe__, vars__).bitField(63, 0).store(fs.access(pe__, vars__).bitField(63, 0).load());
      } else {
        Execution.unpredicted();
      }
    }
  }
}