/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.mips64.mode.*;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class sh extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "sh",
          sh.class,
          null
          );
      addArgument("rt", R.INFO);
      addArgument("offset", SHORT);
      addArgument("base", R.INFO);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R rt = (R) getArgument("rt", args);
      final Immediate offset = (Immediate) getArgument("offset", args);
      final R base = (R) getArgument("base", args);

      return new sh(rt, offset, base);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "sh",
          instruction.class,
          null
          );
      addArgument("rt", R.INFO);
      addArgument("offset", SHORT);
      addArgument("base", R.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R rt = (R) getArgument("rt", args);
      final Immediate offset = (Immediate) getArgument("offset", args);
      final R base = (R) getArgument("base", args);

      return new instruction(
        new sh(
          rt,
          offset,
          base
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final R rt;
  public final Immediate offset;
  public final R base;

  public sh(final R rt, final Immediate offset, final R base) {
    assert R.INFO.isSupported(rt);
    assert SHORT.equals(offset.getType());
    assert R.INFO.isSupported(base);

    this.rt = rt;
    this.offset = offset;
    this.base = base;

    addArgument("rt", rt);
    addArgument("offset", offset);
    addArgument("base", base);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("sh %s, %d(%s)", rt.syntax(vars__), offset.access().load().bigIntegerValue(), base.syntax(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("101001%5s%5s%16s", base.image(vars__), rt.image(vars__), offset.access().load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    new mips64_store(new Immediate(Data.valueOf(Type.CARD(4), 0x2)), rt, offset, base).execute(pe__, vars__);
  }
}